###############################
# Set the configuration knobs #
###############################
macro(DefineRecipeConfigurationKnobs)
    set(CONFIG_SHIP_PLUGINSDK ON)
    set(CONFIG_ENCRYPT_COLLATERAL_IN_SOURCE_RELEASE_BUILDS OFF)
    set(CONFIG_SHIP_PROCESSMANIFEST OFF)
    set(CONFIG_SHIP_CRYPT OFF)
    set(CONFIG_INCLUDE_TESTS OFF)
    set(CONFIG_MANIFEST "")
    set(CONFIG_INCLUDE_STRUCTUREDDATA_ENCRYPTION_SUPPORT OFF)
    set(CONFIG_LICENSE "")
    set(CONFIG_STUB_AUTHORIZATION OFF)
    set(CONFIG_STUB_ENDEBUG ON)
    set(CONFIG_STUB_TELEMETRY ON)
    set(CONFIG_INCLUDE_TEAMCITY_UTILITIES OFF)
    set(CONFIG_MULTIPLATFORM_SOURCE_RELEASE ON)
endmacro()

macro(DefineRecipeCompilerFlags)
endmacro()

###############################
# Include all the ingredients #
###############################
macro(DefineRecipeIngredients)
    # Include ThirdParty libraries
    IncludeIngredient(ThirdPartyLibsBegin)
    IncludeIngredient(ThirdPartyLibs)
    IncludeIngredient(ThirdPartyLibsCatch)
    IncludeIngredient(ThirdPartyLibsBoost)
    IncludeIngredient(ThirdPartyLibsSafeClib)
    IncludeIngredient(ThirdPartyLibsZLib)
    IncludeIngredient(ThirdPartyLibsLibZip)
    IncludeIngredient(ThirdPartyLibsEnd)

    # Foundation is broken up here, if we need to do this in multiple recipes, we should refactor into ingredients
    # Needed for headers
#    add_subdirectory(OpenIPC/Source/Foundation/Error)
#    add_subdirectory(OpenIPC/Source/Foundation/Logging)
    # Below needed for headers :(
#    add_subdirectory(OpenIPC/Source/Foundation/BitData)
    add_subdirectory(OpenIPC/Source/Foundation/BitData_Static)
    # Below is needed for headers, not anything else :(
#    add_subdirectory(OpenIPC/Source/Foundation/IndexList)
    add_subdirectory(OpenIPC/Source/Foundation/IndexList_Static)
    add_subdirectory(OpenIPC/Source/Foundation/JtagLib)
#    add_subdirectory(OpenIPC/Source/Foundation/TelemetryStub)
    add_subdirectory(IPC/Private/InternalUtils)

    add_subdirectory(OpenIPC/Source/PluginSDK/Probe/Source/SDK)
    IncludeIngredient(ASD_Connection_Static)
    IncludeIngredient(ASD_Connection)
    IncludeIngredient(ASD_JTAG_Static)
    IncludeIngredient(ProbePluginASD_JTAG)
#    IncludeIngredient(ProbePluginASD_JTAGSystemTest)
    #IncludeIngredient(ASD_Unit_Tests)
    #IncludeIngredient(ProbePluginStub)
    #IncludeIngredient(ProbePluginExample)

    add_subdirectory(OpenIPC/Source/Foundation/StructuredData_Static)
    add_subdirectory(OpenIPC/Source/Foundation/CommonUtils)
    # Needed for headers
#    add_subdirectory(OpenIPC/Source/Components/Common)
#    add_subdirectory(OpenIPC/Source/Components/Configuration)
    # Needed for Common
#    add_subdirectory(OpenIPC/Source/Foundation/StructuredData)
endmacro()

