/////////////////////////<Source Code Embedded Notices>/////////////////////////
//
// INTEL CONFIDENTIAL
// Copyright (C) Intel Corporation All Rights Reserved.
//
// The source code contained or described herein and all documents related to
// the source code ("Material") are owned by Intel Corporation or its suppliers
// or licensors. Title to the Material remains with Intel Corporation or its
// suppliers and licensors. The Material contains trade secrets and proprietary
// and confidential information of Intel or its suppliers and licensors. The
// Material is protected by worldwide copyright and trade secret laws and
// treaty provisions. No part of the Material may be used, copied, reproduced,
// modified, published, uploaded, posted, transmitted, distributed, or disclosed
// in any way without Intel's prior express written permission.
//
// No license under any patent, copyright, trade secret or other intellectual
// property right is granted to or conferred upon you by disclosure or delivery
// of the Materials, either expressly, by implication, inducement, estoppel or
// otherwise. Any license under such intellectual property rights must be
// express and approved by Intel in writing.
//
/////////////////////////<Source Code Embedded Notices>/////////////////////////
#pragma once

#include <ctime>
#include <string>

namespace CommonUtils
{
    /*!
    @brief Returns the current system time formatted according to the given format spec.
           If the @a milliseconds parameter is provided, the function will store the milliseconds
           part of the current system time in that parameter (because it can't be formatted with
           std::put_time())

    @Notes For the format string specifications, check out the std::put_time() documentation
    */
    std::string FormatTime(const std::string& format, uint32_t* milliseconds);

    /*!
    @brief Returns the given time formatted according to the given format spec

    @Notes For the format string specifications, check out the std::put_time documentation
    */
    std::string FormatTime(const std::string& format, const std::time_t& timestamp);
}
